

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>pywws.device_pyusb &mdash; pywws v12.10 documentation</title>
    <link rel="stylesheet" href="../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '12.10',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <link rel="shortcut icon" href="../_static/pywws_logo.ico"/>
    <link rel="top" title="pywws v12.10 documentation" href="../index.html" />
    <link rel="up" title="Python programs and modules" href="index.html" />
    <link rel="next" title="pywws.DataStore" href="pywws.DataStore.html" />
    <link rel="prev" title="pywws.device_cython_hidapi" href="pywws.device_cython_hidapi.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="pywws.DataStore.html" title="pywws.DataStore"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="pywws.device_cython_hidapi.html" title="pywws.device_cython_hidapi"
             accesskey="P">previous</a> |</li>
        <li><a href="../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="index.html" accesskey="U">Python programs and modules</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <div class="section" id="module-pywws.device_pyusb">
<span id="pywws-device-pyusb"></span><h1>pywws.device_pyusb<a class="headerlink" href="#module-pywws.device_pyusb" title="Permalink to this headline">¶</a></h1>
<p>Low level USB interface to weather station, using PyUSB.</p>
<div class="section" id="introduction">
<h2>Introduction<a class="headerlink" href="#introduction" title="Permalink to this headline">¶</a></h2>
<p>This module handles low level communication with the weather station
via the <a class="reference external" href="http://sourceforge.net/apps/trac/pyusb/">PyUSB</a> library. An
alternative module, <a class="reference internal" href="pywws.device_cython_hidapi.html"><em>pywws.device_cython_hidapi</em></a>, uses the
<a class="reference external" href="https://github.com/gbishop/cython-hidapi">cython-hidapi</a> library.
The choice of which module to use depends on which libraries are
available for you computer.</p>
<p>Users of recent versions of Mac OS have no choice. The operating
system makes it very difficult to access HID devices (such as the
weather station) directly, so the <tt class="docutils literal"><span class="pre">hidapi</span></tt> library has to be used.
<tt class="docutils literal"><span class="pre">cython-hidapi</span></tt> is a Python interface to that library.</p>
<p>Users of OpenWRT and similar embedded Linux platforms will probably
not be able to install <tt class="docutils literal"><span class="pre">cython-hidapi</span></tt>, so are constrained to use
<tt class="docutils literal"><span class="pre">libusb</span></tt> and its <tt class="docutils literal"><span class="pre">PyUSB</span></tt> Python interface.</p>
</div>
<div class="section" id="installation">
<h2>Installation<a class="headerlink" href="#installation" title="Permalink to this headline">¶</a></h2>
<p>Some of this software may already be installed on your machine, so do
check before downloading sources and compiling them yourself.</p>
<ol class="arabic">
<li><p class="first">Install libusb and PyUSB.</p>
<p>These should be available as packages for your operating system,
but their names may vary. For example, on Ubuntu Linux:</p>
<div class="highlight-python"><pre>sudo apt-get install libusb-0.1 python-usb</pre>
</div>
<p>On some embedded linux systems:</p>
<div class="highlight-python"><pre>ipkg install libusb py25-usb</pre>
</div>
</li>
</ol>
</div>
<div class="section" id="testing">
<h2>Testing<a class="headerlink" href="#testing" title="Permalink to this headline">¶</a></h2>
<p>Run <tt class="docutils literal"><span class="pre">TestWeatherStation.py</span></tt> with increased verbosity so it reports
which USB device access module is being used:</p>
<div class="highlight-python"><pre>python TestWeatherStation.py -vv
18:28:09:pywws.WeatherStation.CUSBDrive:using pywws.device_pyusb
0000 55 aa ff ff ff ff ff ff ff ff ff ff ff ff ff ff 05 20 01 41 11 00 00 00 81 00 00 0f 05 00 e0 51
0020 03 27 ce 27 00 00 00 00 00 00 00 12 02 14 18 27 41 23 c8 00 00 00 46 2d 2c 01 64 80 c8 00 00 00
0040 64 00 64 80 a0 28 80 25 a0 28 80 25 03 36 00 05 6b 00 00 0a 00 f4 01 12 00 00 00 00 00 00 00 00
0060 00 00 49 0a 63 12 05 01 7f 00 36 01 60 80 36 01 60 80 bc 00 7b 80 95 28 12 26 6c 28 25 26 c8 01
0080 1d 02 d8 00 de 00 ff 00 ff 00 ff 00 00 11 10 06 01 29 12 02 01 19 32 11 09 09 05 18 12 01 22 13
00a0 14 11 11 04 15 04 11 12 17 05 12 11 09 02 15 26 12 02 11 07 05 11 09 02 15 26 12 02 11 07 05 11
00c0 09 10 09 12 12 02 02 12 38 12 02 07 19 00 11 12 16 03 27 12 02 03 11 00 11 12 16 03 27 11 12 26
00e0 21 32 11 12 26 21 32 12 02 06 19 57 12 02 06 19 57 12 02 06 19 57 12 02 06 19 57 12 02 06 19 57</pre>
</div>
</div>
<div class="section" id="api">
<h2>API<a class="headerlink" href="#api" title="Permalink to this headline">¶</a></h2>
<p class="rubric">Classes</p>
<table border="1" class="docutils">
<colgroup>
<col width="10%" />
<col width="90%" />
</colgroup>
<tbody valign="top">
<tr><td><a class="reference internal" href="#pywws.device_pyusb.USBDevice" title="pywws.device_pyusb.USBDevice"><tt class="xref py py-obj docutils literal"><span class="pre">USBDevice</span></tt></a>(idVendor,&nbsp;idProduct)</td>
<td>Low level USB device access via PyUSB library.</td>
</tr>
</tbody>
</table>
<dl class="class">
<dt id="pywws.device_pyusb.USBDevice">
<em class="property">class </em><tt class="descclassname">pywws.device_pyusb.</tt><tt class="descname">USBDevice</tt><big>(</big><em>idVendor</em>, <em>idProduct</em><big>)</big><a class="reference internal" href="../_modules/pywws/device_pyusb.html#USBDevice"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.device_pyusb.USBDevice" title="Permalink to this definition">¶</a></dt>
<dd><p>Low level USB device access via PyUSB library.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>idVendor</strong> (<em>int</em>) &#8211; the USB <a href="#id1"><span class="problematic" id="id2">``</span></a>vendor ID` number, for example 0x1941.</li>
<li><strong>idProduct</strong> (<em>int</em>) &#8211; the USB <a href="#id3"><span class="problematic" id="id4">``</span></a>product ID` number, for example 0x8021.</li>
</ul>
</td>
</tr>
</tbody>
</table>
<dl class="method">
<dt id="pywws.device_pyusb.USBDevice.read_data">
<tt class="descname">read_data</tt><big>(</big><em>size</em><big>)</big><a class="reference internal" href="../_modules/pywws/device_pyusb.html#USBDevice.read_data"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.device_pyusb.USBDevice.read_data" title="Permalink to this definition">¶</a></dt>
<dd><p>Receive data from the device.</p>
<p>If the read fails for any reason, an <tt class="xref py py-obj docutils literal"><span class="pre">IOError</span></tt> exception
is raised.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first simple">
<li><strong>size</strong> (<em>int</em>) &#8211; the number of bytes to read.</li>
</ul>
</td>
</tr>
<tr class="field"><th class="field-name">Returns:</th><td class="field-body"><p class="first">the data received.</p>
</td>
</tr>
<tr class="field"><th class="field-name">Return type:</th><td class="field-body"><p class="first last">list(int)</p>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="pywws.device_pyusb.USBDevice.write_data">
<tt class="descname">write_data</tt><big>(</big><em>buf</em><big>)</big><a class="reference internal" href="../_modules/pywws/device_pyusb.html#USBDevice.write_data"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.device_pyusb.USBDevice.write_data" title="Permalink to this definition">¶</a></dt>
<dd><p>Send data to the device.</p>
<p>If the write fails for any reason, an <tt class="xref py py-obj docutils literal"><span class="pre">IOError</span></tt> exception
is raised.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first simple">
<li><strong>buf</strong> (<em>list(int)</em>) &#8211; the data to send.</li>
</ul>
</td>
</tr>
<tr class="field"><th class="field-name">Returns:</th><td class="field-body"><p class="first">success status.</p>
</td>
</tr>
<tr class="field"><th class="field-name">Return type:</th><td class="field-body"><p class="first last">bool</p>
</td>
</tr>
</tbody>
</table>
</dd></dl>

</dd></dl>

</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">pywws.device_pyusb</a><ul>
<li><a class="reference internal" href="#introduction">Introduction</a></li>
<li><a class="reference internal" href="#installation">Installation</a></li>
<li><a class="reference internal" href="#testing">Testing</a></li>
<li><a class="reference internal" href="#api">API</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="pywws.device_cython_hidapi.html"
                        title="previous chapter">pywws.device_cython_hidapi</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="pywws.DataStore.html"
                        title="next chapter">pywws.DataStore</a></p>
<div id="searchbox" style="display: none">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" size="18" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="pywws.DataStore.html" title="pywws.DataStore"
             >next</a> |</li>
        <li class="right" >
          <a href="pywws.device_cython_hidapi.html" title="pywws.device_cython_hidapi"
             >previous</a> |</li>
        <li><a href="../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="index.html" >Python programs and modules</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2009-12, Jim Easterbrook.
      Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.0.1.
    </div>
  </body>
</html>